<!-- Panel -->
<div class="container-fluid hd-panel"
    (click)="_onClickPanel()"
    (mouseenter)="_onMouseEnterPanel()"
    (mouseleave)="_onMouseLeavePanel()">
    <!-- Panel Cap -->
    <div class="row hd-panel-cap">
        <div class="col-xs-12" style="text-align: right" *ngIf="!isEditMode && !_revealEditMode && _viewModeHover">
            CLICK TO EDIT
        </div>
    </div>

    <!-- View Panel Contents -->
    <div class="hd-panel-contents" *ngIf="!isEditMode && !_revealEditMode">
        <!-- If this is a multiple-choice question -->

        <!-- If this is a text-field question -->
        <div class="row">
            <div class="col-xs-12 form-group">
                <div class="row">
                    <!-- Answers for the question -->
                    <div class="col-xs-12 col-sm-8">
                        <!-- Text of the question -->
                        <div class="row">
                            <div class="col-xs-12">
                                <label>{{ _question.text }}</label>
                            </div>
                        </div>

                        <!-- Question answer for a text question -->
                        <div *ngIf="!_question.answerChoices" class="row">
                            <div *ngIf="_question.importance >= 1" class="col-xs-12">
                                <p>{{ _question.answer }}</p>
                            </div>
                            <div *ngIf="_question.importance == 0" class="col-xs-12">
                                <p>I don't care about this question</p>
                            </div>
                        </div>

                        <!-- Question answer for a multichoice question -->
                        <div *ngIf="_question.answerChoices" class="row">
                            <div class="col-xs-12">
                                <ul>
                                    <li *ngFor="let answer of _question.answerChoices"
                                        [ngClass]="{'strike-through': (answer != _question.answerChoices[_question.answer])}">
                                        {{ answer }}
                                    </li>
                                </ul>
                                <div *ngIf="_question.importance == 0" class="dont-care">
                                    <p>I don't care about this question</p>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="col-xs-12 col-sm-4 importance-section">
                        <div class="row">
                            <!-- Importance label -->
                            <div class="col-xs-6 col-sm-12">
                                <label>Importance:</label>
                            </div>

                            <!-- Importance Dots -->
                            <div class="col-xs-6 col-sm-12 importance-dot-section">
                                <!-- I Don't Care Importance Level -->
                                <div class="importance-dot importance-dot-active"></div>

                                <!-- That'd Be Nice Importance Level -->
                                <div class="importance-dot"
                                    [ngClass]="{'importance-dot-active': _question.importance >= 1}"></div>

                                <!-- Must Have Importance Level -->
                                <div class="importance-dot"
                                    [ngClass]="{'importance-dot-active': _question.importance == 2}"></div>
                            </div>
                        </div>
                    </div>
                </div>

                <!-- Explanation for the answer -->
                <div class="row" *ngIf="_question.explanation">
                    <div class="col-xs-12">
                        <div class="explanation">Explanation:</div>
                        <p *ngFor="let paragraph of _question.explanation | newLinesToBr">
                            {{ paragraph }}
                        </p>
                    </div>
                </div>
            </div>
        </div>
    </div>

    <!-- Edit Panel Contents -->
    <div class="hd-panel-contents" *ngIf="isEditMode || _revealEditMode">
        <form [formGroup]="_form" (ngSubmit)="_onAnswer()">
            <!-- If this is a multiple-choice question, the multiple choice fields -->
            <div *ngIf='_question.answerChoices' class="row">
                <div class="col-xs-12 form-group" [ngClass]="_formBuilder.groupClass(_formState.answer)">
                    <label for="answer">{{ _question.text }}</label>
                    <div *ngFor="let answer of _question.answerChoices; let i = index">
                        <input type="radio" id="option-{{i}}"[value]="_question.answerChoices.indexOf(answer)" formControlName="answer" />
                        <label for="option-{{i}}">{{ answer }}</label>
                    </div>
                </div>
            </div>

            <!-- If this is a text-field question, the answer text-field -->
            <div *ngIf='!_question.answerChoices' class="row">
                <div class="col-xs-12 form-group" [ngClass]="_formBuilder.groupClass(_formState['answer'])">
                    <label for="answer">{{ _question.text }}</label>
                    <input type="text" id="answer" class="form-control" formControlName="answer" />
                    <form-field-errors id="answerErrors" [field]="_formState['answer']"></form-field-errors>
                </div>
            </div>

            <!-- Importance Label -->
            <div class="row field-pad">
                <div class="col-xs-12">
                    <label>Importance</label>
                </div>
            </div>

            <!-- Importance Options -->
            <div class="row">
                <div class="col-xs-12 form-group">
                    <div class="row">
                        <div class="col-xs-12 importance-buttons">
                            <div class="col-xs-4 importance-button"
                                [ngClass]="{'importance-active': (_importanceHover >= 0 || _form.value.importance != null)}"
                                (click)="_onClick(0)"
                                (mouseenter)="_onMouseEnter(0)"
                                (mouseleave)="_onMouseLeave()"></div>
                            <div class="col-xs-4 importance-button"
                                [ngClass]="{'importance-active': (_importanceHover >= 1 || _form.value.importance >= 1)}"
                                (click)="_onClick(1)"
                                (mouseenter)="_onMouseEnter(1)"
                                (mouseleave)="_onMouseLeave()"></div>
                            <div class="col-xs-4 importance-button"
                                [ngClass]="{'importance-active': (_importanceHover >= 2 || _form.value.importance >= 2)}"
                                (click)="_onClick(2)"
                                (mouseenter)="_onMouseEnter(2)"
                                (mouseleave)="_onMouseLeave()"></div>
                        </div>
                    </div>
                    <div class="row">
                        <div class="col-xs-12">
                            <div class="col-xs-4 importance-button-label">I Don't Care</div>
                            <div class="col-xs-4 importance-button-label">That'd Be Nice</div>
                            <div class="col-xs-4 importance-button-label">Must Have</div>
                        </div>
                    </div>
                </div>
            </div>

            <!-- Optional field for the developer to explain their answer -->
            <div class="row field-pad">
                <div class="col-xs-12 form-group" [ngClass]="_formBuilder.groupClass(_formState.explanation)">
                    <label for="explanation">Explain your answer (optional)</label>
                    <textarea id="explanation" class="form-control" formControlName="explanation" rows="4"
                            placeholder="Write a brief explanation of your answer..."></textarea>
                    <form-field-errors id="explanationError" [field]="_formState.explanation"></form-field-errors>
                </div>
            </div>

            <!-- Unexpected error message -->
            <div class="row" *ngIf="_unexpectedError">
                <div class="col-xs-12">
                    An unexpected error occurred while trying to save your answer!
                </div>
            </div>

            <!-- Answer / Skip Question Buttons -->
            <div class="row">
                <div class="col-xs-6">
                    <button type="submit" class="btn btn-primary btn-answer" [disabled]="!_form.valid" id="answerButton">Answer</button>
                </div>
                <div class="col-xs-6 skip-question">
                    <a *ngIf="!_revealEditMode" id='skipButton' (click)="_onSkipQuestion()">Skip Question</a>
                    <a *ngIf="_revealEditMode" id='cancelButton' (click)="_onClickCancel($event)">Cancel</a>
                </div>
            </div>
        </form>
    </div>
</div>
